package com.docus.server.infrastructure.dao.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.docus.core.util.Func;
import com.docus.infrastructure.core.db.dao.impl.BaseDaoImpl;
import com.docus.infrastructure.web.request.SearchDTO;
import com.docus.infrastructure.web.response.PageResult;
import com.docus.server.entity.scheduling.management.SchSystemParams;
import com.docus.server.infrastructure.dao.ISchSystemParamsDao;
import com.docus.server.infrastructure.mapper.SchSystemParamsMapper;
import com.github.pagehelper.PageHelper;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.List;

/**
 * 系统参数表 数据访问实现类
 *
 * @author AutoGenerator
 * @since 2023-07-15
 */
@Repository
public class SchSystemParamsDaoImpl extends BaseDaoImpl<SchSystemParamsMapper, SchSystemParams> implements ISchSystemParamsDao {

    /**
     * 按主键查询
     *
     * @param id 主键Id
     * @return 实体
     */
    @Override
    public SchSystemParams findById(String id) {
        return super.findById(id);
    }

    /**
     * 新增
     *
     * @param schSystemParams 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean add(SchSystemParams schSystemParams) {
        return super.save(schSystemParams);
    }

    /**
     * 编辑
     *
     * @param schSystemParams 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean edit(SchSystemParams schSystemParams) {
        return super.updateById(schSystemParams);
    }

    /**
     * 批量删除
     *
     * @param ids 主键ids
     * @return 成功或失败
     */
    @Override
    public int delete(List<Long> ids) {
        return super.deleteByIds(ids);
    }

    /**
     * 关键字搜索
     *
     * @param searchDTO 搜索参数
     * @return 分页列表
     */
    @Override
    public PageResult<SchSystemParams> search(SearchDTO searchDTO) {
        //分页
        PageHelper.startPage(searchDTO.getPageNum(), searchDTO.getPageSize());
        LambdaQueryWrapper<SchSystemParams> query = Wrappers.lambdaQuery();
        //时间范围，默认按createTime
        if (searchDTO.getBeginTime() != null) {
            query.ge(SchSystemParams::getCreateTime, searchDTO.getBeginTime());
        }
        if (searchDTO.getEndTime() != null) {
            Date endTime = searchDTO.getEndTime();
            query.le(SchSystemParams::getCreateTime, endTime);
        }

        //分组查询系统参数表
        String paramGroup = String.valueOf(searchDTO.getParams("paramGroup"));
        if (Func.isNotBlank(paramGroup)) {
            query.eq(SchSystemParams::getParamGroup, paramGroup);
        }

        //默认createTime倒序排序
        query.orderByDesc(SchSystemParams::getCreateTime);
        List<SchSystemParams> list = super.find(query);
        return new PageResult<>(list);
    }

}
